package com.landray.kmss.sys.attachment.restservice.foxit.controller.dao;

import java.io.Serializable;

public class Results<T> implements Serializable
{
    private static final long serialVersionUID = 4240749068084741071L;
    private Integer code;
    private String msg;
    private T data;
    
    public Results() {
    }
    
    public Results(final String msg, final Integer code, final T data) {
        this.msg = msg;
        this.code = code;
        this.data = data;
    }
    
    public static <T> Results<T> ok() {
        return new Results<T>("success", 0, null);
    }
    
    public static <T> Results<T> ok(final T data) {
        return new Results<T>("success", 0, data);
    }
    
    public static <T> Results<T> ok(final String msg) {
        return new Results<T>(msg, 0, null);
    }
    
    public static <T> Results<T> ok(final String msg, final T data) {
        return new Results<T>(msg, 0, data);
    }
    
    public static <T> Results<T> fail() {
        return new Results<T>("fail", 1, null);
    }
    
    public static <T> Results<T> fail(final String msg) {
        return new Results<T>(msg, 1, null);
    }
    
    public static <T> Results<T> fail(final int code, final String msg) {
        return new Results<T>(msg, code, null);
    }
    
    public Results<T> data(final T data) {
        this.data = data;
        return this;
    }
    
    public boolean isOk() {
        return this.getCode() == 0;
    }
    
    public Integer getCode() {
        return this.code;
    }
    
    public void setCode(final Integer code) {
        this.code = code;
    }
    
    public String getMsg() {
        return this.msg;
    }
    
    public void setMsg(final String msg) {
        this.msg = msg;
    }
    
    public T getData() {
        return this.data;
    }
    
    public void setData(final T data) {
        this.data = data;
    }
}
